Index: dnspython-1.12.0/dns/ipv6.py
===================================================================
--- dnspython-1.12.0.orig/dns/ipv6.py
+++ dnspython-1.12.0/dns/ipv6.py
@@ -16,11 +16,13 @@
 """IPv6 helper functions."""
 
 import re
+import binascii
 
 import dns.exception
 import dns.ipv4
+from ._compat import xrange, binary_type
 
-_leading_zero = re.compile(r'0+([0-9a-f]+)')
+_leading_zero = re.compile(b'0+([0-9a-f]+)')
 
 def inet_ntoa(address):
     """Convert a network format IPv6 address into text.
@@ -33,7 +35,7 @@ def inet_ntoa(address):
 
     if len(address) != 16:
         raise ValueError("IPv6 addresses are 16 bytes long")
-    hex = address.encode('hex_codec')
+    hex = binascii.hexlify(address)
     chunks = []
     i = 0
     l = len(hex)
@@ -55,7 +57,7 @@ def inet_ntoa(address):
     start = -1
     last_was_zero = False
     for i in xrange(8):
-        if chunks[i] != '0':
+        if chunks[i] != b'0':
             if last_was_zero:
                 end = i
                 current_len = end - start
@@ -75,23 +77,23 @@ def inet_ntoa(address):
     if best_len > 1:
         if best_start == 0 and \
            (best_len == 6 or
-            best_len == 5 and chunks[5] == 'ffff'):
+            best_len == 5 and chunks[5] == b'ffff'):
             # We have an embedded IPv4 address
             if best_len == 6:
-                prefix = '::'
+                prefix = b'::'
             else:
-                prefix = '::ffff:'
+                prefix = b'::ffff:'
             hex = prefix + dns.ipv4.inet_ntoa(address[12:])
         else:
-            hex = ':'.join(chunks[:best_start]) + '::' + \
-                  ':'.join(chunks[best_start + best_len:])
+            hex = b':'.join(chunks[:best_start]) + b'::' + \
+                  b':'.join(chunks[best_start + best_len:])
     else:
-        hex = ':'.join(chunks)
+        hex = b':'.join(chunks)
     return hex
 
-_v4_ending = re.compile(r'(.*):(\d+\.\d+\.\d+\.\d+)$')
-_colon_colon_start = re.compile(r'::.*')
-_colon_colon_end = re.compile(r'.*::$')
+_v4_ending = re.compile(b'(.*):(\d+\.\d+\.\d+\.\d+)$')
+_colon_colon_start = re.compile(b'::.*')
+_colon_colon_end = re.compile(b'.*::$')
 
 def inet_aton(text):
     """Convert a text format IPv6 address into network format.
@@ -105,17 +107,19 @@ def inet_aton(text):
     #
     # Our aim here is not something fast; we just want something that works.
     #
+    if not isinstance(text, binary_type):
+        text = text.encode()
 
-    if text == '::':
-        text = '0::'
+    if text == b'::':
+        text = b'0::'
     #
     # Get rid of the icky dot-quad syntax if we have it.
     #
     m = _v4_ending.match(text)
     if not m is None:
-        b = dns.ipv4.inet_aton(m.group(2))
-        text = "%s:%02x%02x:%02x%02x" % (m.group(1), ord(b[0]), ord(b[1]),
-                                         ord(b[2]), ord(b[3]))
+        b = bytearray(dns.ipv4.inet_aton(m.group(2)))
+        text = (u"%s:%02x%02x:%02x%02x" % (m.group(1).decode(), b[0], b[1],
+                                           b[2], b[3])).encode()
     #
     # Try to turn '::<whatever>' into ':<whatever>'; if no match try to
     # turn '<whatever>::' into '<whatever>:'
@@ -130,39 +134,39 @@ def inet_aton(text):
     #
     # Now canonicalize into 8 chunks of 4 hex digits each
     #
-    chunks = text.split(':')
+    chunks = text.split(b':')
     l = len(chunks)
     if l > 8:
         raise dns.exception.SyntaxError
     seen_empty = False
     canonical = []
     for c in chunks:
-        if c == '':
+        if c == b'':
             if seen_empty:
                 raise dns.exception.SyntaxError
             seen_empty = True
             for i in xrange(0, 8 - l + 1):
-                canonical.append('0000')
+                canonical.append(b'0000')
         else:
             lc = len(c)
             if lc > 4:
                 raise dns.exception.SyntaxError
             if lc != 4:
-                c = ('0' * (4 - lc)) + c
+                c = (b'0' * (4 - lc)) + c
             canonical.append(c)
     if l < 8 and not seen_empty:
         raise dns.exception.SyntaxError
-    text = ''.join(canonical)
+    text = b''.join(canonical)
 
     #
     # Finally we can go to binary.
     #
     try:
-        return text.decode('hex_codec')
-    except TypeError:
+        return binascii.unhexlify(text)
+    except (binascii.Error, TypeError):
         raise dns.exception.SyntaxError
 
-_mapped_prefix = '\x00' * 10 + '\xff\xff'
+_mapped_prefix = b'\x00' * 10 + b'\xff\xff'
 
 def is_mapped(address):
     return address.startswith(_mapped_prefix)
Index: dnspython-1.12.0/dns/message.py
===================================================================
--- dnspython-1.12.0.orig/dns/message.py
+++ dnspython-1.12.0/dns/message.py
@@ -15,8 +15,9 @@
 
 """DNS Messages"""
 
-import cStringIO
-import random
+from __future__ import absolute_import
+
+from io import StringIO
 import struct
 import sys
 import time
@@ -36,6 +37,8 @@ import dns.renderer
 import dns.tsig
 import dns.wiredata
 
+from ._compat import long, xrange, string_types
+
 class ShortHeader(dns.exception.FormError):
     """Raised if the DNS packet passed to from_wire() is too short."""
     pass
@@ -173,7 +176,7 @@ class Message(object):
         self.index = {}
 
     def __repr__(self):
-        return '<DNS message, ID ' + `self.id` + '>'
+        return '<DNS message, ID ' + repr(self.id) + '>'
 
     def __str__(self):
         return self.to_text()
@@ -187,41 +190,45 @@ class Message(object):
         @rtype: string
         """
 
-        s = cStringIO.StringIO()
-        print >> s, 'id %d' % self.id
-        print >> s, 'opcode %s' % \
-              dns.opcode.to_text(dns.opcode.from_flags(self.flags))
+        s = StringIO()
+        s.write(u'id %d\n' % self.id)
+        s.write(u'opcode %s\n' %
+                dns.opcode.to_text(dns.opcode.from_flags(self.flags)))
         rc = dns.rcode.from_flags(self.flags, self.ednsflags)
-        print >> s, 'rcode %s' % dns.rcode.to_text(rc)
-        print >> s, 'flags %s' % dns.flags.to_text(self.flags)
+        s.write(u'rcode %s\n' % dns.rcode.to_text(rc))
+        s.write(u'flags %s\n' % dns.flags.to_text(self.flags))
         if self.edns >= 0:
-            print >> s, 'edns %s' % self.edns
+            s.write(u'edns %s\n' % self.edns)
             if self.ednsflags != 0:
-                print >> s, 'eflags %s' % \
-                      dns.flags.edns_to_text(self.ednsflags)
-            print >> s, 'payload', self.payload
+                s.write(u'eflags %s\n' %
+                        dns.flags.edns_to_text(self.ednsflags))
+            s.write(u'payload %d\n' % self.payload)
         is_update = dns.opcode.is_update(self.flags)
         if is_update:
-            print >> s, ';ZONE'
+            s.write(u';ZONE\n')
         else:
-            print >> s, ';QUESTION'
+            s.write(u';QUESTION\n')
         for rrset in self.question:
-            print >> s, rrset.to_text(origin, relativize, **kw)
+            s.write(rrset.to_text(origin, relativize, **kw))
+            s.write(u'\n')
         if is_update:
-            print >> s, ';PREREQ'
+            s.write(u';PREREQ\n')
         else:
-            print >> s, ';ANSWER'
+            s.write(u';ANSWER\n')
         for rrset in self.answer:
-            print >> s, rrset.to_text(origin, relativize, **kw)
+            s.write(rrset.to_text(origin, relativize, **kw))
+            s.write(u'\n')
         if is_update:
-            print >> s, ';UPDATE'
+            s.write(u';UPDATE\n')
         else:
-            print >> s, ';AUTHORITY'
+            s.write(u';AUTHORITY\n')
         for rrset in self.authority:
-            print >> s, rrset.to_text(origin, relativize, **kw)
-        print >> s, ';ADDITIONAL'
+            s.write(rrset.to_text(origin, relativize, **kw))
+            s.write(u'\n')
+        s.write(u';ADDITIONAL\n')
         for rrset in self.additional:
-            print >> s, rrset.to_text(origin, relativize, **kw)
+            s.write(rrset.to_text(origin, relativize, **kw))
+            s.write(u'\n')
         #
         # We strip off the final \n so the caller can print the result without
         # doing weird things to get around eccentricities in Python print
@@ -273,7 +280,7 @@ class Message(object):
            dns.opcode.from_flags(other.flags):
             return False
         if dns.rcode.from_flags(other.flags, other.ednsflags) != \
-               dns.rcode.NOERROR:
+                dns.rcode.NOERROR:
             return True
         if dns.opcode.is_update(self.flags):
             return True
@@ -327,9 +334,9 @@ class Message(object):
         key = (self.section_number(section),
                name, rdclass, rdtype, covers, deleting)
         if not force_unique:
-            if not self.index is None:
+            if self.index is not None:
                 rrset = self.index.get(key)
-                if not rrset is None:
+                if rrset is not None:
                     return rrset
             else:
                 for rrset in section:
@@ -339,7 +346,7 @@ class Message(object):
             raise KeyError
         rrset = dns.rrset.RRset(name, rdclass, rdtype, covers, deleting)
         section.append(rrset)
-        if not self.index is None:
+        if self.index is not None:
             self.index[key] = rrset
         return rrset
 
@@ -416,7 +423,7 @@ class Message(object):
         for rrset in self.additional:
             r.add_rrset(dns.renderer.ADDITIONAL, rrset, **kw)
         r.write_header()
-        if not self.keyname is None:
+        if self.keyname is not None:
             r.add_tsig(self.keyname, self.keyring[self.keyname],
                        self.fudge, self.original_id, self.tsig_error,
                        self.other_data, self.request_mac,
@@ -455,7 +462,7 @@ class Message(object):
         if keyname is None:
             self.keyname = self.keyring.keys()[0]
         else:
-            if isinstance(keyname, (str, unicode)):
+            if isinstance(keyname, string_types):
                 keyname = dns.name.from_text(keyname)
             self.keyname = keyname
         self.keyalgorithm = algorithm
@@ -467,7 +474,8 @@ class Message(object):
         self.tsig_error = tsig_error
         self.other_data = other_data
 
-    def use_edns(self, edns=0, ednsflags=0, payload=1280, request_payload=None, options=None):
+    def use_edns(self, edns=0, ednsflags=0, payload=1280, request_payload=None,
+                 options=None):
         """Configure EDNS behavior.
         @param edns: The EDNS level to use.  Specifying None, False, or -1
         means 'do not use EDNS', and in this case the other parameters are
@@ -499,7 +507,7 @@ class Message(object):
             options = []
         else:
             # make sure the EDNS version in ednsflags agrees with edns
-            ednsflags &= 0xFF00FFFFL
+            ednsflags &= long(0xFF00FFFF)
             ednsflags |= (edns << 16)
             if options is None:
                 options = []
@@ -537,7 +545,7 @@ class Message(object):
         (value, evalue) = dns.rcode.to_flags(rcode)
         self.flags &= 0xFFF0
         self.flags |= value
-        self.ednsflags &= 0x00FFFFFFL
+        self.ednsflags &= long(0x00FFFFFF)
         self.ednsflags |= evalue
         if self.ednsflags != 0 and self.edns < 0:
             self.edns = 0
@@ -556,7 +564,9 @@ class Message(object):
         self.flags &= 0x87FF
         self.flags |= dns.opcode.to_flags(opcode)
 
+
 class _WireReader(object):
+
     """Wire format reader.
 
     @ivar wire: the wire-format message.
@@ -600,12 +610,12 @@ class _WireReader(object):
 
         for i in xrange(0, qcount):
             (qname, used) = dns.name.from_wire(self.wire, self.current)
-            if not self.message.origin is None:
+            if self.message.origin is not None:
                 qname = qname.relativize(self.message.origin)
             self.current = self.current + used
             (rdtype, rdclass) = \
-                     struct.unpack('!HH',
-                                   self.wire[self.current:self.current + 4])
+                struct.unpack('!HH',
+                              self.wire[self.current:self.current + 4])
             self.current = self.current + 4
             self.message.find_rrset(self.message.question, qname,
                                     rdclass, rdtype, create=True,
@@ -630,15 +640,15 @@ class _WireReader(object):
             rr_start = self.current
             (name, used) = dns.name.from_wire(self.wire, self.current)
             absolute_name = name
-            if not self.message.origin is None:
+            if self.message.origin is not None:
                 name = name.relativize(self.message.origin)
             self.current = self.current + used
             (rdtype, rdclass, ttl, rdlen) = \
-                     struct.unpack('!HHIH',
-                                   self.wire[self.current:self.current + 10])
+                struct.unpack('!HHIH',
+                              self.wire[self.current:self.current + 10])
             self.current = self.current + 10
             if rdtype == dns.rdatatype.OPT:
-                if not section is self.message.additional or seen_opt:
+                if section is not self.message.additional or seen_opt:
                     raise BadEDNS
                 self.message.payload = rdclass
                 self.message.ednsflags = ttl
@@ -648,10 +658,11 @@ class _WireReader(object):
                 optslen = rdlen
                 while optslen > 0:
                     (otype, olen) = \
-                            struct.unpack('!HH',
-                                          self.wire[current:current + 4])
+                        struct.unpack('!HH',
+                                      self.wire[current:current + 4])
                     current = current + 4
-                    opt = dns.edns.option_from_wire(otype, self.wire, current, olen)
+                    opt = dns.edns.option_from_wire(
+                        otype, self.wire, current, olen)
                     self.message.options.append(opt)
                     current = current + olen
                     optslen = optslen - 4 - olen
@@ -670,31 +681,31 @@ class _WireReader(object):
                     dns.tsig.get_algorithm_and_mac(self.wire, self.current,
                                                    rdlen)
                 self.message.tsig_ctx = \
-                                      dns.tsig.validate(self.wire,
-                                          absolute_name,
-                                          secret,
-                                          int(time.time()),
-                                          self.message.request_mac,
-                                          rr_start,
-                                          self.current,
-                                          rdlen,
-                                          self.message.tsig_ctx,
-                                          self.message.multi,
-                                          self.message.first)
+                    dns.tsig.validate(self.wire,
+                                      absolute_name,
+                                      secret,
+                                      int(time.time()),
+                                      self.message.request_mac,
+                                      rr_start,
+                                      self.current,
+                                      rdlen,
+                                      self.message.tsig_ctx,
+                                      self.message.multi,
+                                      self.message.first)
                 self.message.had_tsig = True
             else:
                 if ttl < 0:
                     ttl = 0
                 if self.updating and \
                    (rdclass == dns.rdataclass.ANY or
-                    rdclass == dns.rdataclass.NONE):
+                        rdclass == dns.rdataclass.NONE):
                     deleting = rdclass
                     rdclass = self.zone_rdclass
                 else:
                     deleting = None
                 if deleting == dns.rdataclass.ANY or \
-                   (deleting == dns.rdataclass.NONE and \
-                    section is self.message.answer):
+                   (deleting == dns.rdataclass.NONE and
+                        section is self.message.answer):
                     covers = dns.rdatatype.NONE
                     rd = None
                 else:
@@ -707,7 +718,7 @@ class _WireReader(object):
                 rrset = self.message.find_rrset(section, name,
                                                 rdclass, rdtype, covers,
                                                 deleting, True, force_unique)
-                if not rd is None:
+                if rd is not None:
                     rrset.add(rd, ttl)
             self.current = self.current + rdlen
 
@@ -732,14 +743,14 @@ class _WireReader(object):
         if not self.ignore_trailing and self.current != l:
             raise TrailingJunk
         if self.message.multi and self.message.tsig_ctx and \
-               not self.message.had_tsig:
+                not self.message.had_tsig:
             self.message.tsig_ctx.update(self.wire)
 
 
 def from_wire(wire, keyring=None, request_mac='', xfr=False, origin=None,
-              tsig_ctx = None, multi = False, first = True,
-              question_only = False, one_rr_per_rrset = False,
-              ignore_trailing = False):
+              tsig_ctx=None, multi=False, first=True,
+              question_only=False, one_rr_per_rrset=False,
+              ignore_trailing=False):
     """Convert a DNS wire format message into a message
     object.
 
@@ -793,6 +804,7 @@ def from_wire(wire, keyring=None, reques
 
 
 class _TextReader(object):
+
     """Text format reader.
 
     @ivar tok: the tokenizer
@@ -830,13 +842,13 @@ class _TextReader(object):
                     self.tok.unget(token)
                     break
                 self.message.flags = self.message.flags | \
-                                     dns.flags.from_text(token.value)
+                    dns.flags.from_text(token.value)
             if dns.opcode.is_update(self.message.flags):
                 self.updating = True
         elif what == 'edns':
             self.message.edns = self.tok.get_int()
             self.message.ednsflags = self.message.ednsflags | \
-                                     (self.message.edns << 16)
+                (self.message.edns << 16)
         elif what == 'eflags':
             if self.message.edns < 0:
                 self.message.edns = 0
@@ -846,7 +858,7 @@ class _TextReader(object):
                     self.tok.unget(token)
                     break
                 self.message.ednsflags = self.message.ednsflags | \
-                              dns.flags.edns_from_text(token.value)
+                    dns.flags.edns_from_text(token.value)
         elif what == 'payload':
             self.message.payload = self.tok.get_int()
             if self.message.edns < 0:
@@ -854,7 +866,7 @@ class _TextReader(object):
         elif what == 'opcode':
             text = self.tok.get_string()
             self.message.flags = self.message.flags | \
-                      dns.opcode.to_flags(dns.opcode.from_text(text))
+                dns.opcode.to_flags(dns.opcode.from_text(text))
         elif what == 'rcode':
             text = self.tok.get_string()
             self.message.set_rcode(dns.rcode.from_text(text))
@@ -865,7 +877,7 @@ class _TextReader(object):
     def _question_line(self, section):
         """Process one line from the text format question section."""
 
-        token = self.tok.get(want_leading = True)
+        token = self.tok.get(want_leading=True)
         if not token.is_whitespace():
             self.last_name = dns.name.from_text(token.value, None)
         name = self.last_name
@@ -898,7 +910,7 @@ class _TextReader(object):
 
         deleting = None
         # Name
-        token = self.tok.get(want_leading = True)
+        token = self.tok.get(want_leading=True)
         if not token.is_whitespace():
             self.last_name = dns.name.from_text(token.value, None)
         name = self.last_name
@@ -941,7 +953,7 @@ class _TextReader(object):
         rrset = self.message.find_rrset(section, name,
                                         rdclass, rdtype, covers,
                                         deleting, True, self.updating)
-        if not rd is None:
+        if rd is not None:
             rrset.add(rd, ttl)
 
     def read(self):
@@ -996,6 +1008,7 @@ def from_text(text):
 
     return m
 
+
 def from_file(f):
     """Read the next text format message from the specified file.
 
@@ -1005,15 +1018,11 @@ def from_file(f):
     @raises dns.exception.SyntaxError:
     @rtype: dns.message.Message object"""
 
-    if sys.hexversion >= 0x02030000:
-        # allow Unicode filenames; turn on universal newline support
-        str_type = basestring
-        opts = 'rU'
-    else:
-        str_type = str
-        opts = 'r'
+    str_type = string_types
+    opts = 'rU'
+
     if isinstance(f, str_type):
-        f = file(f, opts)
+        f = open(f, opts)
         want_close = True
     else:
         want_close = False
@@ -1025,7 +1034,8 @@ def from_file(f):
             f.close()
     return m
 
-def make_query(qname, rdtype, rdclass = dns.rdataclass.IN, use_edns=None,
+
+def make_query(qname, rdtype, rdclass=dns.rdataclass.IN, use_edns=None,
                want_dnssec=False, ednsflags=0, payload=1280,
                request_payload=None, options=None):
     """Make a query message.
@@ -1061,11 +1071,11 @@ def make_query(qname, rdtype, rdclass =
     @see: RFC 2671
     @rtype: dns.message.Message object"""
 
-    if isinstance(qname, (str, unicode)):
+    if isinstance(qname, string_types):
         qname = dns.name.from_text(qname)
-    if isinstance(rdtype, (str, unicode)):
+    if isinstance(rdtype, string_types):
         rdtype = dns.rdatatype.from_text(rdtype)
-    if isinstance(rdclass, (str, unicode)):
+    if isinstance(rdclass, string_types):
         rdclass = dns.rdataclass.from_text(rdclass)
     m = Message()
     m.flags |= dns.flags.RD
@@ -1075,6 +1085,7 @@ def make_query(qname, rdtype, rdclass =
     m.want_dnssec(want_dnssec)
     return m
 
+
 def make_response(query, recursion_available=False, our_payload=8192,
                   fudge=300):
     """Make a message which is a response for the specified query.
